class ProcStream{
	// fixed members

	SPPointFilter m_PF;  // united with markers: 0=black, 1=grey, 2=white, 4+x=marker
	SPPointCollector m_PC;
	SPMarkers m_Mrk;
	QuickCorrector []m_QC;
	SPAngleKeeper m_AX,m_AY;
	int m_NF;
	int m_TStep;  // 2*actual TStep

	bool m_HavePts,m_RunProc,m_RunMarker;
	int m_Idx;
	int m_T0;
	double []phx;

	double []phs,ams;


	void AddPoint(int []pt){
		int T=pt[0]<<1;
		if(m_HavePts){
			int dt=T-m_T0;
			if(m_TStep==0 && (dt==80 || (dt>=600 && dt<=1000))) m_TStep=dt;
			if(dt<=0 || dt>m_TStep*MaxPSkip){

			}
			int pskip=Math.Max(1,dt/m_TStep);
			m_Idx+=pskip;
			int ia=4*m_NF+1;
			if(pt[ia+1]>=0) m_AX.AddAngle(m_Idx,pt[ia+1],pt[ia]);
			if(pt[ia+3]>=0) m_AY.AddAngle(m_Idx,pt[ia+3],pt[ia+2]);
			int M=0;
			double ax=0,ay=0;
			if(m_AX.HaveAngle && m_AY.HaveAngle){
				ax=m_AX.GetAngle();
				ay=m_AY.GetAngle();
				M=m_PF.GetStatus(ax,ay);
			}
			if(m_RunProc) M++;  // 0,1 - off, 2,3 - on
			if(M>=2){
				for(int i=0;i<m_NF;i++){
					AmpDistPt pp=m_QC[i].ConvertFlt(pt[4*i],pt[4*i+1]); // int,int => double,double (ph,rel)
					phs[i]=pp.Phase; // modulo 1, with PhZ applied
					ams[i]=pp.Amp;
				}
				if((M&2)!=0){
					if(!m_RunProc) m_PC.RunNewLine(ax,ay);
					m_PC.AddPoint(ax,ay,am,phs);
					m_RunProc=true;
				}else{
					if(m_RunProc) m_PC.CloseLine();
					m_RunProc=false;
				}
				if((M&4)!=0){
					if(!m_RunMarker) m_Mrk.RunNewLine();
					m_Mrk.AddPoint(ax,am,phs);
					m_RunMarker=true;
				}else{
					m_Mrk.CloseLine(phx); // fill with phase corrections
					m_RunMarker=false;
				}
			}
		}
	}

}




















class AngleKeep{
    int ALast;
	int IndLast;
	double TLast;
	double VCur;

	bool HaveAng;

	double PCf;
	int TStep;

	void AddAngle(int ind,int dt,int val,out int NP,out double A0,out double dA){
		NP=0;
		A0=dA=0;
		double T=(ind-1)+(double)dt/TStep;
		if(HaveAng){
			double da=(val-ALast)*PCf;
			da-=Math.Round(da);
			if(Math.Abs(da)<0.005){

			}else{

			}
		}
	
	
	
	
	}